<?php
	set_time_limit(0);

	include_once 'app/cfg_app.php';
	require_once 'app/serviceclient/lib/init.php';
	require_once 'app/serviceclient/services/' . MCP__CREDITCARDSERVICE_INTERFACE . '.php';
	require_once MCP__SERVICELIB_DISPATCHER . 'TNvpServiceDispatcher.php';

	function _r($name, $default = '', $prefix = 'card_') {
		$name = $prefix . $name;
		return isset($_REQUEST[$name]) ? $_REQUEST[$name] : $default;
	}


$debug = array();
$debug['start'] = date('Y-m-d H:i:s');

$time_start = microtime(true);
ob_start();
try {

	$key = MCP__ACCESSKEY;

//  Variante festlegen für die Buchung. Entweder tokenSessionCreate gefolgt von transactionPurchase
//  oder man verwendet tokenPurchase. Beide Varianten sind gleichwertig.
//
//	$variante = 'tokensessionCreate_transactionPurchase';
    $variante = 'tokenPurchase';


// parameter entgegennehmen
	$holder = _r('holder');
	$month = _r('month');
	$year = _r('year');
	$pan = _r('pan');
	$cvc = _r('cvc');
	$token = _r('token');

	$debug['NVP_URL'] = MCP__CREDITCARDSERVICE_NVP_URL;
    $debug['SERVICE_INTERFACE'] = MCP__CREDITCARDSERVICE_INTERFACE;
    $debug['TESTMODE'] = $testMode;
    $debug['VARIANTE'] = $variante;
	$dispatcher = new TNvpServiceDispatcher(MCP__CREDITCARDSERVICE_INTERFACE, MCP__CREDITCARDSERVICE_NVP_URL);

	//$ip = $_SERVER["REMOTE_ADDR"]; für Livebetrieb !!!
	$ip = '172.217.22.110'; // dummy, für Tests von localhost etc.

	$time_start2 = microtime(true);

    $urlNotify = (isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] === 'on') ? 'https://' : 'http://';
    $urlNotify.= $_SERVER['HTTP_HOST'] . dirname($_SERVER['SCRIPT_NAME']) . '/2step-3dsecure-api_purchase_3dnotify.php';

    if($testMode){
        $urlNotify.= '?testMode=1';
    }
    if($variante === 'tokensessionCreate_transactionPurchase') {

        $res = $dispatcher->tokenSessionCreate($key, $testMode,
            $token, //token
            'Karl Heinz Knigge',    //firstname
            $holder, //surname
            null,    //doublet
            null,    //email
            null,    //culture
            null,    //customerId
            null,    //freeParams
            $project, //project
            null,    //projectCampaign
            null,    //account
            null,    //webmasterCampaign
            $amount, //amount
            $currency, //currency
            'Die ganze Welt', //title
            null, //paytext
            $ip, //ip
            0, //sendMail
            null, //freeParamsSession
            null, //sessionId
            null //update
        );

        if (empty($res)) {
            throw new Exception('Session invalid');
        }
        $debug['tokenSessionCreate']['RESULT'] = $res;
        $sessionId = $res['sessionId'];
        if (empty($sessionId)) {
            throw new Exception('Session empty');
        }

        $debug['tokenSessionCreate']['STATUS'] = 'OK';

        // Buchung ----------------------
        $cvc2 = null; // wenn kein cvc übergeben wird aber in der Session ein Token hinterlegt ist, wird dieser für den cvc herangezogen !!


        $fraudDetection = false;
        $avsCheck = false;
        $recurring = 0;
        $start3d = 1;
        $res = $dispatcher->transactionPurchase($key, $testMode,
            $sessionId,
            $cvc2,
            $fraudDetection,
            $avsCheck,
            $recurring,
            $start3d,
            $urlNotify
        );
        if(empty($res)) throw new Exception('transactionPurchase Error');

        $debug['transactionPurchase']['RESULT'] = $res;

        if($res['secureStatus'] === 'START3D'){
            $url = $res['forwardUrl'];
            if(!empty($url)){
                header('Location: ' . $url, true, 307);
                exit;
            }
        }
    } elseif($variante === 'tokenPurchase') {
        $res = $dispatcher->tokenPurchase($key, $testMode,
            $token, //token
            null, 	//firstname
            $holder, //surname
            null, 	//doublet
            null, 	//email
            null, 	//culture
            null, 	//customerId
            null, 	//freeParams
            $project, //project
            null, 	//projectCampaign
            null, 	//account
            null, 	//webmasterCampaign
            $amount, //amount
            $currency, //currency
            'Die ganze Welt', //title
            null, //paytext
            $_SERVER["REMOTE_ADDR"], //ip
            0, //sendMail
            null, //freeParamsSession
            null, //sessionId
            null, //cvc2
            1,    //fraudDetection
            0,    //avsCheck
            null, //update
            0, // recurring
            1, // start3d
            $urlNotify
        );
        if(empty($res)) throw new Exception('tokenPurchase Error');

        $sessionId = $res['sessionId'];
        $debug['tokenPurchase']['RESULT'] = $res;

        if($res['secureStatus'] === 'START3D'){
            $url = $res['forwardUrl'];
            if(!empty($url)){
                header('Location: ' . $url, true, 307);
                exit;
            }
        }
    }

    $debug['STATUS'] = 'ok';

} catch (Exception $e) {
	$debug['STATUS'] = 'EXCEPTION';
	$debug['EXCEPTION'] = $e->getMessage();
	$debug['EXCEPTION_ID'] = $e->getCode();
}
$info = ob_get_contents();
ob_end_clean();
$debug['dauer'] = microtime(true) - $time_start;
$debug['info'] = $info;








?>
<!DOCTYPE html>
<html lang="de">
<head>
	<title>micropayment Kreditkarten Demo</title>
	<meta charset="utf-8" />
	<meta http-equiv="X-UA-Compatible" content="IE=edge" />
	<meta name="viewport" content="width=device-width, initial-scale=1" />
	<meta name="description" content="micropayment GmbH - Kreditkarten Demo" />
	<meta name="author" content="micropayment GmbH" />

	<!-- Bootstrap Core CSS -->
	<link href="css/bootstrap.min.css" rel="stylesheet" />

	<!-- Custom CSS -->
	<link href="css/cc-spezial.css" rel="stylesheet" />

	<!-- Custom Fonts -->
	<link href="font-awesome/css/font-awesome.min.css" rel="stylesheet" type="text/css" />

</head>
<body>

<div class="container">
		<fieldset>

			<div class="form-group">
<pre>
<?php
$msg = sprintf("%01.2f", $amount / 100) . ' ' . $currency . "\n";
$msg.= 'holder: ' . $holder . "\n";
$msg.= 'pan: ' . $pan . "\n";
$msg.= 'cvc: ' . $cvc . "\n";
$msg.= 'month/year: ' . $month . '/' . $year . "\n";
$msg.= 'token: ' . $token . "\n";
$msg.= 'sessionId: ' . $sessionId . "\n";
echo htmlspecialchars($msg);
?>
</pre>
			</div>


			<hr />
			<h4><small>© 2015 by <a href="http://www.micropayment.de" target="_blank">micropayment</a></small></h4>

		</fieldset>

</div>

<script src="js/jquery.js"></script>
<script src="js/bootstrap.min.js"></script>

<script>
	$(function () {
		$('[data-toggle="tooltip"]').tooltip()
	})
</script>
<a href='2step-api-session_a.php'>restart</a>
</body>
</html>
<?php include 'app/tpl/inc.debug.php';?>